// Terrible hack for resizing
window.onresize = function() {
  var f = function() {
    var newH = window.innerHeight * 0.99 - 3 + "px";
    document.getElementById('log').parentNode.style.height = newH;
    document.getElementById('log2').parentNode.style.height = newH;
  }
  setTimeout(f, 100);
}

window.onload = window.onresize;

var graph = {};
var roots = [];
var garbage = [];
var searchGeneration = 0;

function ensureObject(aAddress) {
  if (!graph[aAddress]) {
    graph[aAddress] =
      {
        name: "",
        address: null,
        refcount: 0,
        gcmarked: false,
        root: false,
        garbage: false,
        knownEdges: 0,
        edges: [],
        owners: [],
        searchMark: 0
      }
  }
  return graph[aAddress];
}

function setLog(s, append) {
  var log = document.getElementById("log");
  if (log.firstChild) {
    if (append) {
      log.firstChild.data += "\n" + s;
    } else {
      log.firstChild.data = s;
    }
  } else {
    log.textContent = s;
  }
}

function setLog2(s, append) {
  var log = document.getElementById("log2");
  if (log.firstChild) {
    if (append) {
      log.firstChild.data += "\n" + s;
    } else {
      log.firstChild.data = s;
    }
  } else {
    log.textContent = s;
  }
}

function cc() {
  setLog("Log area 1");
  setLog("Log area 2");
  graph = {};
  roots = [];
  garbage = [];
	var l = Components.classes["@mozilla.org/cycle-collector-logger;1"].createInstance(Components.interfaces.nsICycleCollectorListener);
	if (document.getElementById("alltraces") && document.getElementById("alltraces").checked) {
	  l.allTraces();
	}
	l.disableLog = true;
	l.wantAfterProcessing = true;
	window.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIDOMWindowUtils).garbageCollect(l);
	var s = "";
	var h = 
	{
	  noteRefCountedObject: function(aAddress, aRefCount, aObjectDescription) {
	    var o = ensureObject(aAddress);
	    o.address = aAddress;
	    o.refcount = aRefCount;
	    o.name = aObjectDescription;
	  },
	  noteGCedObject: function(aAddress, aMarked, aObjectDescription) {
	    var o = ensureObject(aAddress);
	    o.address = aAddress;
	    o.gcmarked = aMarked;
	    o.name = aObjectDescription;
	  },
	  noteEdge: function(aFromAddress, aToAddress, aEdgeName) {
	    var fromObject = ensureObject(aFromAddress);
	    var toObject = ensureObject(aToAddress);
	    fromObject.edges.push({ name: aEdgeName, to: toObject });
	    toObject.owners.push({ name: aEdgeName, from: fromObject });
	  },
	  describeRoot: function(aAddress, aKnownEdges) {
	    var o = ensureObject(aAddress);
	    o.root = true;
	    o.knownEdges = aKnownEdges;
	    roots.push(o);
	  },
	  describeGarbage: function(aAddress) {
	    var o = ensureObject(aAddress);
	    o.garbage = true;
	    garbage.push(o);
	  }
	};
  while (l.processNext(h));
  setLog(Object.keys(graph).length + " objects\n" +
         roots.length + " roots\n" +
         garbage.length + " garbage\n");
}

function printRoots() {
  var s = "";
  for each (var o in roots) {
    var res = [];
    getChildObjects(o, res, ++searchGeneration);
    s += serializeObject(o) + "\n" +
         "    is a root of graph with size " + res.length + "\n";
  }
  setLog2(s);
}

function getChildObjects(o, res, searchGen)
{
  if (o.searchMark == searchGen) {
    return;
  }
  o.searchMark = searchGen;
  res.push(o);
  for each (var edge in o.edges) {
    getChildObjects(edge.to, res, searchGen);
  }
}

function getEdges(o) {
  var s = "";
  for each (var e in o.edges) {
    s += "    > " + e.to.address + " " + e.name + "\n";
  }
  return s;
}

function serializeObject(o) {
  var s = "";
  if (o.refcount) {
    s += o.address +
         " [rc=" + o.refcount + "] " +
         (o.garbage ? "garbage " : "") +
         (o.root ? "root " : "") +
         o.name;
  } else {
    s += o.address +
         " [gc" + (o.gcmarked ? ".marked" : "") + "] " +
         (o.garbage ? "garbage " : "") +
         (o.root ? "root " : "") +
         o.name;    
  }
  return s;
}

function allObjects() {
  var s = "";
  for each (var o in graph) {
    s += serializeObject(o) + "\n" + getEdges(o);
  }
  setLog(s, true);
}

function findObjects(name) {
  var s = "";
  for each (var o in graph) {
    if (o.name.indexOf(name) >= 0 || o.address.indexOf(name) >= 0) {
      s += serializeObject(o) + "\n";
    }
  }
  setLog2(s);
}

function findRoots(addr) {
  var o = graph[addr];
  if (!o) {
    setLog2("Unknown object");
    return;
  }
  var res = [];
  getRootObjects(o, res, ++searchGeneration);
  setLog2("Roots: " + res.length + "\n" + res.join("\n"));
}

function getRootObjects(o, res, searchGen)
{
  if (o.searchMark == searchGen) {
    return;
  }

  o.searchMark = searchGen;
  if (o.root) {
    res.push(serializeObject(o));
  }

  for each (var owner in o.owners) {
    getRootObjects(owner.from, res, searchGen);
  }
}

function findGraph(addr) {
  var o = graph[addr];
  if (!o) {
    setLog2("Unknown object");
    return;
  }
  var res = [];
  getObjectGraph(o, res, ++searchGeneration);
  setLog2("Graph: \n" + res.join("\n"));
}

function getObjectGraph(o, res, searchGen)
{
  if (o.searchMark == searchGen) {
    return;
  }

  o.searchMark = searchGen;
  res.push(serializeObject(o));

  for each (var edge in o.edges) {
    getObjectGraph(edge.to, res, searchGen);
  }
  for each (var owner in o.owners) {
    getObjectGraph(owner.from, res, searchGen);
  }
}
