Components.utils.import("resource://gre/modules/Services.jsm");

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cu = Components.utils;
const Cm = Components.manager;

Cm.QueryInterface(Ci.nsIComponentRegistrar);

Cu.import("resource://gre/modules/XPCOMUtils.jsm");
Cu.import("resource://gre/modules/Services.jsm");
Cu.import("resource://gre/modules/AddonManager.jsm");

const MY_URL = "resource://cclog-addon/";

Cm.QueryInterface(Ci.nsIComponentRegistrar);

Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

function AboutCC() {}

AboutCC.prototype = {
  QueryInterface: XPCOMUtils.generateQI([Ci.nsIAboutModule]),
  classDescription: "about:cc",
  classID: Components.ID("{1b44f837-58e7-4f54-8542-413d13b6d61e}"),
  contractID: "@mozilla.org/network/protocol/about;1?what=cc",

  newChannel: function(uri)
  {
    var ioService = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
    var html = 'data:text/html,<!DOCTYPE html><html><head>\n' 
               + '<link href="' + MY_URL + 'stylesheet.css" rel="stylesheet" type="text/css">\n'
               + '<script src="' + MY_URL + 'aboutcc.js" type="application/javascript;version=1.8"></script>\n'
               + '</head><body>\n';
    html += "<table><tr><td>\n";
//    html += "All traces (slow!): <input type='checkbox' id='alltraces'><br>\n";
    html += "<input type='button' onclick='cc();setTimeout(allObjects, 500);' value='Run cycle collector'><br>\n";
    html += "<input type='button' onclick='printRoots();' value='Roots'><br>\n";

    html += "Find roots (address):<br>\n";
    html += "<input type='text' id='address'><br>\n";
    html += "<input type='button' value='Search' onclick='findRoots(document.getElementById(\"address\").value);'><hr>\n";

    html += "Find graph (address):<br>\n";
    html += "<input type='text' id='address2'><br>\n";
    html += "<input type='button' value='Search' onclick='findGraph(document.getElementById(\"address2\").value);'><hr>\n";
    
    html += "Find objects containing (name or address):<br>\n";
    html += "<input type='text' id='objname'><br>\n";
    html += "<input type='button' value='Search' onclick='findObjects(document.getElementById(\"objname\").value);'><hr>\n";

    html += "</td><td>\n";
    html += "<div class='rc'><pre id='log'>Log area 1</pre></div>\n";
    html += "</td><td>\n";
    html += "<div class='rc'><pre id='log2'>Log area 2</pre></div>\n";
    html += "</td></tr></table>\n";
    html += "</body></html>\n";

    var channel = ioService.newChannel(html, null, null);
    var securityManager = Cc["@mozilla.org/scriptsecuritymanager;1"].getService(Ci.nsIScriptSecurityManager);
    var principal = securityManager.getSystemPrincipal();
    channel.originalURI = uri;
    channel.owner = principal;
    return channel;
  },

  getURIFlags: function(uri)
  {
    return Ci.nsIAboutModule.ALLOW_SCRIPT;
  }
}

const AboutCCFactory =
  XPCOMUtils.generateNSGetFactory([AboutCC])(AboutCC.prototype.classID);

var global = this;

function startup(aData, aReason) {
  let resource = Services.io.getProtocolHandler("resource").QueryInterface(Ci.nsIResProtocolHandler);
  let alias = Services.io.newFileURI(aData.installPath);
  if (!aData.installPath.isDirectory())
    alias = Services.io.newURI("jar:" + alias.spec + "!/", null, null);
  resource.setSubstitution("cclog-addon", alias);
  Cm.registerFactory(AboutCC.prototype.classID,
                     AboutCC.prototype.classDescription,
                     AboutCC.prototype.contractID,
                     AboutCCFactory);
}

function shutdown(aData, aReason) {
  if (aReason == APP_SHUTDOWN) {
    return;
  }

  let resource = Services.io.getProtocolHandler("resource").QueryInterface(Ci.nsIResProtocolHandler);
  resource.setSubstitution("cclog-addon", null);
  Cm.unregisterFactory(AboutCC.prototype.classID,
                       AboutCCFactory);
}

function install(aData, aReason) { }
function uninstall(aData, aReason) { }
